Find objects using comparison and logical operators

*Prefix:* `find`

*Value:* Vector of operators

*Can start the pipeline:* Yes

*Steps before:* find, get, sort, limit, offset

*Steps after:* find, get, sort, limit, offset, update, delete

## Comparison operators

- Equal - `eq{...}`
- Not equal - `neq{...}`
- Greater than - `gt{...}`
- Greater than or equeal - `gte{...}`
- Less than - `lt{...}`
- Less than or equal - `lte{...}`
- Less than or equal - `lte{...}`

## Logical operators

- And - `and[...]`
- Or - `or[...]`
- Not - `not(...)`

In order to compare the value of the object `root path` notation could be used:

```shell
eq{root: s|bar|}
```

In order to compare a field of the object `path to value` notation could be used:

```shell
eq{value|path.to.field|: s|bar|}
```

## Example

Input:

<pre><code><span class="prefix_primitive">collection</span>|<span class="value_primitive">test</span>|:<span class="prefix_vector">find</span>[
	<span class="prefix_map">gt</span>{
		<span class="prefix_primitive">value</span>|<span class="value_primitive">num</span>|:<span class="prefix_number">n</span>|<span class="value_number">4</span>|,
	},
];
</code></pre>

Output:

<pre><code><span class="prefix_primitive">result</span>:<span class="prefix_vector">ok</span>[
	<span class="prefix_map">response</span>{
		<span class="prefix_string">s</span>|<span class="value_string">data</span>|:<span class="prefix_map">objects</span>{
			<span class="prefix_link">test</span>|<span class="value_link">836e2b67-c77e-40b9-9ce4-677cea9246c0</span>|:<span class="prefix_map">m</span>{
				<span class="prefix_string">s</span>|<span class="value_string">name</span>|:<span class="prefix_string">s</span>|<span class="value_string">test_6</span>|,
				<span class="prefix_string">s</span>|<span class="value_string">num</span>|:<span class="prefix_number">n</span>|<span class="value_number">6</span>|,
			},
			<span class="prefix_link">test</span>|<span class="value_link">0c004536-6c16-4225-9a5f-65636af178de</span>|:<span class="prefix_map">m</span>{
				<span class="prefix_string">s</span>|<span class="value_string">num</span>|:<span class="prefix_number">n</span>|<span class="value_number">5</span>|,
				<span class="prefix_string">s</span>|<span class="value_string">name</span>|:<span class="prefix_string">s</span>|<span class="value_string">test_5</span>|,
			},
			<span class="prefix_link">test</span>|<span class="value_link">84f51626-c54c-4e19-980d-c008ef651438</span>|:<span class="prefix_map">m</span>{
				<span class="prefix_string">s</span>|<span class="value_string">name</span>|:<span class="prefix_string">s</span>|<span class="value_string">test_7</span>|,
				<span class="prefix_string">s</span>|<span class="value_string">num</span>|:<span class="prefix_number">n</span>|<span class="value_number">7</span>|,
			},
			<span class="prefix_link">test</span>|<span class="value_link">c855b99c-a992-40ba-a075-416125d5e72a</span>|:<span class="prefix_map">m</span>{
				<span class="prefix_string">s</span>|<span class="value_string">num</span>|:<span class="prefix_number">n</span>|<span class="value_number">8</span>|,
				<span class="prefix_string">s</span>|<span class="value_string">name</span>|:<span class="prefix_string">s</span>|<span class="value_string">test_8</span>|,
			},
			<span class="prefix_link">test</span>|<span class="value_link">01aa0816-e505-46cb-9e60-4cb93dce6699</span>|:<span class="prefix_map">m</span>{
				<span class="prefix_string">s</span>|<span class="value_string">num</span>|:<span class="prefix_number">n</span>|<span class="value_number">9</span>|,
				<span class="prefix_string">s</span>|<span class="value_string">name</span>|:<span class="prefix_string">s</span>|<span class="value_string">test_9</span>|,
			},
		},
		<span class="prefix_string">s</span>|<span class="value_string">meta</span>|:<span class="prefix_map">find_meta</span>{
			<span class="prefix_string">s</span>|<span class="value_string">count</span>|:<span class="prefix_number">n</span>|<span class="value_number">5</span>|,
		},
	},
];
</code></pre>